# Templates

---

![](../assets/one-does-not-simply-learn-templates-in-c.jpg)

* Templates are how C++ programmers can do _generic programming_.
* Generic programming means writing data structures and algorithms without regards for a specific type.
* Templates are very powerful, but can be complicated to write. However, they are easy to use.

```cpp
//Don’t do this
int IntegerDataStructure::next();
string StringDataStructure::next();
Foo FooDataStructure::next();

//Do this instead
T DataStructure<T>::next();
```

### DO NOT FEAR!

This will be covered in Ch4: Overloading and Templates

